"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const nextTick = (callback, ...args) => typeof setImmediate !== 'undefined' ? setImmediate(callback, ...args) : setTimeout(callback, 0, ...args);
function parallelLimit(tasks, limit, cb) {
    let pending = tasks.length;
    let len = tasks.length;
    let next = limit;
    const results = [];
    function done() {
        if (cb) {
            cb(results);
            cb = null;
        }
    }
    function poll(index, err, result) {
        results[index] = err || result;
        if (--pending === 0) {
            nextTick(done);
        }
        else if (next < len) {
            const key = next;
            const task = tasks[key];
            next += 1;
            task(function (err, result) {
                nextTick(poll, key, err, result);
            });
        }
    }
    if (!pending) {
        done();
    }
    else {
        tasks.some((task, i) => {
            task((err, result) => {
                nextTick(poll, i, err, result);
            });
            if (i === limit - 1) {
                return true;
            }
        });
    }
}
exports.parallelLimit = parallelLimit;
//# sourceMappingURL=parallel-limit.js.map